from django.core.paginator import Paginator

from DCbackend.utils.common import success, fail, pageData
from backend.Form.BrandForm import BrandForm
from backend.models import ProjectCategory, Brand


class BrandService:

    @staticmethod
    def Create(request):
        form = BrandForm(request.POST)
        if form.is_valid():
            form.save()
            return success("成功")
        else:
            return fail(form.errors)

    @staticmethod
    def Update(request):
        data = Brand.objects.filter(id=request.POST.get("id")).first();
        if data is not None:
            data.intro = request.POST.get("intro")
            data.name = request.POST.get("name")
            data.status = request.POST.get("status")
            data.save()
            return success("成功")
        else:
            return fail("更新品牌信息失败")

    @staticmethod
    def Info(request):
        info = Brand.objects.filter(id=request.POST.get("id")).first()
        return success(BrandService.getDetail(info))

    @staticmethod
    def Delete(request):
        Brand.objects.filter(id=request.POST.get("id")).update(status=4)
        return success("成功")

    @staticmethod
    def getDetail(item: Brand):
        return {
            "id": item.id,
            'intro': item.intro,
            'name': item.name,
            'createTime': item.create_time,
            'status': item.status
        }

    @staticmethod
    def Search(request):
        page = request.POST.get("page")
        pageSize = request.POST.get("pageSize")
        if page is None:
            page = 1
        if pageSize is None:
            pageSize = 1

        where = {}


        name = request.POST.get("name", '')
        if name:
            where["name__icontains"] = name

        status = request.POST.get("status")
        if status:
            where['status'] = status

        paginator = Paginator(Brand.objects.filter(**where).exclude(status=4).order_by("-id"),
                              pageSize)  # 每页显示10条数据
        page_obj = paginator.get_page(page)
        dataList = []
        for item in page_obj:
            info = BrandService.getDetail(item)
            dataList.append(info)
        return success(pageData(page, pageSize, paginator.num_pages, paginator.count, dataList))
